package org.linagora.linshare.core.domain.entities;

import java.util.Calendar;
import java.util.HashSet;
import java.util.Set;

import org.linagora.linshare.core.domain.constants.EntryType;

public abstract class Entry {

	protected long id;
	
	protected Account entryOwner;
	
	protected Calendar creationDate;
	
	protected Calendar modificationDate;
	
	protected Calendar expirationDate;
	
	protected String name;
	
	protected String comment;
	
	protected String uuid;
	
	private Set<EntryTagAssociation> tagAssociations = new HashSet<EntryTagAssociation>();
	
	
	public Entry() {
	}
	
	public Entry(Account entryOwner, String name, String comment) {
		this.entryOwner = entryOwner;
		this.name = name;
		this.comment = comment;
	}
	
	public abstract EntryType getEntryType();
	
	public String getUuid() {
		return uuid;
	}

	public void setUuid(String uuid) {
		this.uuid = uuid;
	}

	public long getId() {
		return id;
	}
	
	public void setId(long id) {
		this.id = id;
	}

	public Account getEntryOwner() {
		return entryOwner;
	}

	public void setEntryOwner(Account entryOwner) {
		this.entryOwner = entryOwner;
	}

	public Calendar getCreationDate() {
		return creationDate;
	}

	public void setCreationDate(Calendar creationDate) {
		this.creationDate = creationDate;
	}

	public Calendar getModificationDate() {
		return modificationDate;
	}

	public void setModificationDate(Calendar modificationDate) {
		this.modificationDate = modificationDate;
	}

	public Calendar getExpirationDate() {
		return expirationDate;
	}

	public void setExpirationDate(Calendar expirationDate) {
		this.expirationDate = expirationDate;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((uuid == null) ? 0 : uuid.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Entry other = (Entry) obj;
		if (uuid == null) {
			if (other.uuid != null)
				return false;
		} else if (!uuid.equals(other.uuid))
			return false;
		return true;
	}

	public Set<EntryTagAssociation> getTagAssociations() {
		return tagAssociations;
	}

	public void setTagAssociations(Set<EntryTagAssociation> tagAssociations) {
		this.tagAssociations = tagAssociations;
	}
	
	

	
//	@Override
//	public int hashCode() {
//		final int prime = 31;
//		int result = 1;
//		result = prime * result + ((uuid == null) ? 0 : uuid.hashCode());
//		return result;
//	}
//
//	@Override
//	public boolean equals(Object obj) {
//		if (this == obj)
//			return true;
//		if (obj == null)
//			return false;
//		if (getClass() != obj.getClass())
//			return false;
//		Entry other = (Entry) obj;
//		if (uuid == null) {
//			if (other.uuid != null)
//				return false;
//		} else if (!uuid.equals(other.uuid))
//			return false;
//		return true;
//	}

}
