/*
 *    This file is part of Linshare.
 *
 *   Linshare is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as
 *   published by the Free Software Foundation, either version 3 of
 *   the License, or (at your option) any later version.
 *
 *   Linshare is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public
 *   License along with Foobar.  If not, see
 *                                    <http://www.gnu.org/licenses/>.
 *
 *   (c) 2008 Groupe Linagora - http://linagora.org
 *
*/
package org.linagora.linshare.view.tapestry.models;

import java.util.Comparator;
import java.util.List;

import org.linagora.linshare.view.tapestry.enums.Order;

public interface SorterModel<T> {

	/**
	 * Give the comparator which permits to order the list.
	 * You have to make comparator in the ASC order. (the Sorter components do a Collection.reverse() if the order is DESC...)
	 * 
	 * @return the comparator which permits to order the list. Return null if it's the natural order which will be use (for comparable Object).
	 */
	public Comparator<T> getComparator(String fieldId);
	
	/**
	 * Give the order ASC (by default) or DESC.
	 * @return the order to return the list.
	 */
	public Order getOrder(String fieldId);
	
	
	/**
	 * Give the list to sort.
	 * @return the list to sort.
	 */
	public List<T> getListToSort();
	
}
